*==>chkeq.gms  Subprogram called by cinch.gms and energy.gms

$if not defined ndchk scalar ndchk /6/;

parameter       profity(r,i)    Y sector profit check
                profitm(r,i)    M sector profit check
                marketx(r,i)    Export market check
                marketm(r,i)    Import market check
                marketi(r,i)    Intermediate input market check;


profity(r,i) = round( (vdm(i,r) + vxm(i,r)) * (1 - ty(i,r)) - sum(j, vafm(j,i,r) * (1+ti(j,i,r)))
        - sum(f, vfm(f,i,r)*(1 + tf(f,i,r))), ndchk);

profitm(r,i) = round( vim(i,r) - sum(s, (vxmd(i,s,r)*(1 + tx(i,s,r)) + vtwr(i,s,r))*(1 + tm(i,s,r))), ndchk);

marketx(r,i) = round( vxm(i,r) - vst(i,r) - sum(s, vxmd(i,r,s)), ndchk);

marketm(r,i) = round( vim(i,r) - sum(s,(vxmd(i,s,r)*(1+tx(i,s,r))+vtwr(i,s,r))*(1+tm(i,s,r))), ndchk);

marketi(r,i) = round( vdfm(i,r) + vifm(i,r) - sum(j, vafm(i,j,r)), ndchk);

display "Absolute deviations:", profity, profitm, marketx, marketm, marketi;



profity(r,i)$profity(r,i) = round(100 * ( (vdm(i,r) + vxm(i,r)) * (1 - ty(i,r))
        - sum(j, vafm(j,i,r) * (1+ti(j,i,r)))
        - sum(f, vfm(f,i,r)*(1 + tf(f,i,r))) ) / (vdm(i,r)+vxm(i,r)));

profitm(r,i)$profitm(r,i)  = round( 100 * (
        vim(i,r) - sum(s, (vxmd(i,s,r)*(1 + tx(i,s,r)) + vtwr(i,s,r))*(1 + tm(i,s,r)))) / vim(i,r) );

marketx(r,i)$marketx(r,i) = round( 100 * (vxm(i,r) - vst(i,r) - sum(s, vxmd(i,r,s))) / vxm(i,r));

marketm(r,i)$marketm(r,i) = round( 100 * (
        vim(i,r) - sum(s,(vxmd(i,s,r)*(1+tx(i,s,r))+vtwr(i,s,r))*(1+tm(i,s,r))) ) / vim(i,r));

marketi(r,i)$marketi(r,i) = round( 100 * ( vdfm(i,r) + vifm(i,r) - sum(j, vafm(i,j,r)) ) / (vdfm(i,r)+vifm(i,r)));

option profity:0, profitm:0, marketx:0, marketm:0, marketi:0;
display "Percentage deviations:", profity, profitm, marketx, marketm, marketi;
